unit _opengl;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, dglOpenGL, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel; Panel2: TPanel; Label1: TLabel; Edit1: TEdit;
    CheckBox1: TCheckBox; Button1: TButton; Label2: TLabel;
    Label3: TLabel; Label4: TLabel; Label5: TLabel; Label6: TLabel;
    Label7: TLabel; Label8: TLabel; Edit2: TEdit; Edit3: TEdit;
    Edit4: TEdit; Edit5: TEdit; Edit6: TEdit; Edit7: TEdit;
    Edit8: TEdit; Edit9: TEdit; Edit10: TEdit; Edit11: TEdit;
    Edit12: TEdit; Edit13: TEdit; Edit14: TEdit; Edit15: TEdit;
    Edit16: TEdit; Edit17: TEdit; Edit18: TEdit; Edit19: TEdit;
    Edit20: TEdit; Edit21: TEdit; Edit22: TEdit; Edit23: TEdit;
    Edit24: TEdit; Edit25: TEdit; Edit26: TEdit; Label9: TLabel;
    Label10: TLabel; Button2: TButton; Panel3: TPanel; Memo1: TMemo;
    Label11: TLabel; Label12: TLabel;
    CheckBox2: TCheckBox; CheckBox3: TCheckBox;
    CheckBox4: TCheckBox; CheckBox5: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Render;
    procedure OnIdle(Sender: TObject; var Done: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
  { Private declarations }
    StartTime, TimeCount, FrameCount : Cardinal;
    Frames, DrawTime : Cardinal;
    procedure ErrorHandler;
    procedure Action;
    procedure Mitte;
    procedure Licht;
  public
  { Public declarations }
  end;

var
  Form1: TForm1;
  DC, RC :HDC;
  rotation : double;
  t, t1, t2, x, y, z : single;
  mouse_x, mouse_y : Integer;
  turn, schritt : single;
  maus_flag : boolean;
  mat_light : Array[1..25] of GlFloat;

implementation
{$R *.dfm}


procedure TForm1.FormCreate(Sender: TObject);
begin
  Button2.Click;
  Panel3.Visible := false;
  Panel3.Enabled := false;
  Form1.Width := Form1.Width - 180;
  
  InitOpenGL;
  DC:=GetDC(Form1.Panel1.Handle);
  //GoToFullscreen(1024, 768, 32, 75);
  RC:=CreateRenderingContext(DC, [opDoubleBuffered], 32, 24, 0, 0, 0, 0);
  ActivateRenderingContext(DC, RC);
  glClearColor(0.0, 0.0, 0.0, 0.0);
  Application.OnIdle:=Onidle;
  rotation:=0;

  x := 0; y := -3; z := -12; t := 0; t1 := 0; t2 := 0;
  mouse_x := mouse.CursorPos.X;
  mouse_y := mouse.CursorPos.Y;
  maus_flag := false;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  DeactivateRenderingContext;
  DestroyRenderingContext(RC);
  ReleaseDC(Form1.Panel1.Handle,DC);
  ChangeDisplaySettings(devmode(nil^), 0);
end;

procedure TForm1.Render;
begin
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  glViewport(0, 0, Panel1.Width, Panel1.Height);
  gluPerspective(60, Panel1.Width/Panel1.Height, 0.5, 128);
  glMatrixMode(GL_Modelview);
  glLoadIdentity;
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

//  AntiAliasing - einschalten
  glEnable(GL_LINE_SMOOTH);

//  Tiefentest - einschalten
  glEnable( GL_DEPTH_TEST );

// Licht ausschalten, damit die Mitte gezeigt werden kann
  glDisable(GL_LIGHTING);

  glTranslatef(x, y, z);
  glRotatef(t, 0, 1, 0);
  glRotatef(t1, 1, 0, 0);

// Mittelpunkt anzeigen - Linien zeigen alle in die positive Richtungen
  Mitte;

// Licht einschalten
  if CheckBox1.Checked then Licht;

  Action;

  SwapBuffers(DC);
end;

procedure TForm1.ErrorHandler;
begin
//  Form1.Caption := gluErrorString(glGetError);
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Label1.Caption := 'Key: ' + IntToStr(key);

  if key = 33 then y := y + schritt;
  if key = 34 then y := y - schritt;
  if key = 37 then x := x + schritt;
  if key = 39 then x := x - schritt;
  if key = 38 then z := z + schritt;
  if key = 40 then z := z - schritt;

  if key = 27 then Application.Terminate;
end;

procedure TForm1.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if not maus_flag then
  begin
    mouse_x := mouse.CursorPos.X;
    mouse_y := mouse.CursorPos.Y;
  end;
  maus_flag := true;
end;

procedure TForm1.Panel1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  maus_flag := false;
end;

procedure TForm1.Onidle(Sender: TObject; var Done: Boolean);
begin
  StartTime := GetTickCount;
  Render;
  DrawTime := GetTickCount - StartTime;
  Inc(TimeCount, DrawTime);
  Inc(FrameCount);

  if TimeCount >= 1000 then
  begin
    Frames := FrameCount;
    TimeCount := TimeCount - 1000;
    FrameCount := 0;
    Form1.Caption := IntToStr(Frames) + 'FPS';
    ErrorHandler;
  end;

  if maus_flag then
  begin
    if mouse_x <> mouse.CursorPos.X then
    begin
      if mouse_x > mouse.CursorPos.X then t := t - (mouse_x - mouse.CursorPos.x)
       else t := t + (mouse.CursorPos.x - mouse_x);
      mouse_x := mouse.CursorPos.X;
    end;
    if mouse_y <> mouse.CursorPos.y then
    begin
      if mouse_y > mouse.CursorPos.y then t1 := t1 - (mouse_y - mouse.CursorPos.y)
       else t1 := t1 + (mouse.CursorPos.y - mouse_y);
      mouse_y := mouse.CursorPos.y;
    end;
  end;

  Done:= false;
end;

procedure TForm1.Mitte;
begin
// Koordinatenkreuz Mittelpunkt setzen
  glColor3f(1, 0, 0);
  glBegin(GL_LINES);
    glVertex3f(0,0,0); glVertex3f(1,0,0);
  glEnd;
  glColor3f(0, 1, 0);
  glBegin(GL_LINES);
    glVertex3f(0,0,0); glVertex3f(0,1,0);
  glEnd;
  glColor3f(0, 0, 1);
  glBegin(GL_LINES);
    glVertex3f(0,0,0); glVertex3f(0,0,1);
  glEnd;
end;

procedure TForm1.Action;
var
  Quad1, Quad2 : PGLUquadric;
begin
  glColor3f(1, 1, 0);
// Kugel
  gltranslatef(0, 1.5, 0);
  if CheckBox4.Checked then
  begin
    Quad2 := gluNewQuadric;
    gluSphere(Quad2, 1, 32, 32);
  end;

// Wrfel
  glColor3f(0, 0, 1);
  gltranslatef(3, 0, 0);

  if CheckBox5.Checked then
  begin
    glBegin(GL_QUADS);
      glVertex3f(-0.5,-0.5,0.5); glVertex3f(-0.5,0.5,0.5);
      glVertex3f(0.5,0.5,0.5); glVertex3f(0.5,-0.5,0.5);
    glEnd;
    glBegin(GL_QUADS);
      glVertex3f(-0.5,-0.5,-0.5); glVertex3f(-0.5,0.5,-0.5);
      glVertex3f(0.5,0.5,-0.5); glVertex3f(0.5,-0.5,-0.5);
    glEnd;
    glBegin(GL_QUADS);
      glVertex3f(-0.5,0.5,0.5); glVertex3f(-0.5,0.5,-0.5);
      glVertex3f(0.5,0.5,-0.5); glVertex3f(0.5,0.5,0.5);
    glEnd;
    glBegin(GL_QUADS);
      glVertex3f(-0.5,-0.5,0.5); glVertex3f(-0.5,-0.5,-0.5);
      glVertex3f(0.5,-0.5,-0.5); glVertex3f(0.5,-0.5,0.5);
    glEnd;
    glBegin(GL_QUADS);
      glVertex3f(-0.5,-0.5,-0.5); glVertex3f(-0.5,0.5,-0.5);
      glVertex3f(-0.5,0.5,0.5); glVertex3f(-0.5,-0.5,0.5);
    glEnd;
    glBegin(GL_QUADS);
      glVertex3f(0.5,-0.5,-0.5); glVertex3f(0.5,0.5,-0.5);
      glVertex3f(0.5,0.5,0.5); glVertex3f(0.5,-0.5,0.5);
    glEnd;
  end;

// Kegel
  glColor3f(0, 1, 0);
  gltranslatef(-6, 2, 0);
  glrotatef(90, 1, 0, 0);

  if CheckBox3.Checked then
  begin
    Quad1 := gluNewQuadric;
    gluCylinder(Quad1, 0, 1, 3, 32, 32);
  end;

// Ebene
  glColor3f(1, 0, 0);
  gltranslatef(3, 0, 4);
  glrotatef(-90, 1, 0, 0);

  if CheckBox2.Checked then
  begin
    glBegin(GL_QUADS);
      glVertex3f(-4,0,-4);
      glVertex3f(-4,0,4);
      glVertex3f(4,0,4);
      glVertex3f(4,0,-4);
    glEnd;
  end;
end;

procedure TForm1.Licht;
var
  mat_specular  : Array[0..3] of GlFloat;
  mat_shininess : Array[0..0] of GlFloat;
  mat_ambient   : Array[0..3] of GlFloat;
  mat_diffuse   : Array[0..3] of GlFloat;

  light_position : Array[0..3] of GlFloat;
  light_ambient  : Array[0..3] of GlFloat;
  light_diffuse  : Array[0..3] of GlFloat;
begin
  mat_specular[0] := mat_light[22]; mat_specular[1] := mat_light[23];
  mat_specular[2] := mat_light[24]; mat_specular[3] := mat_light[25];
  mat_shininess[0] := mat_light[21];
  mat_diffuse[0] := mat_light[17]; mat_diffuse[1] := mat_light[18];
  mat_diffuse[2] := mat_light[19]; mat_diffuse[3] := mat_light[20];
  mat_ambient[0] := mat_light[13]; mat_ambient[1] := mat_light[14];
  mat_ambient[2] := mat_light[15]; mat_ambient[3] := mat_light[16];
  light_position[0] := mat_light[9]; light_position[1] := mat_light[10];
  light_position[2] := mat_light[11]; light_position[3] := mat_light[12];
  light_diffuse[0] := mat_light[5]; light_diffuse[1] := mat_light[6];
  light_diffuse[2] := mat_light[7]; light_diffuse[3] := mat_light[8];
  light_ambient[0] := mat_light[1]; light_ambient[1] := mat_light[2];
  light_ambient[2] := mat_light[3]; light_ambient[3] := mat_light[4];
  glMaterialfv(GL_FRONT, GL_SPECULAR, @mat_specular[0]);
  glMaterialfv(GL_FRONT, GL_SHININESS, @mat_shininess[0]);
  glMaterialfv(GL_FRONT, GL_AMBIENT, @mat_ambient[0]);
  glMaterialfv(GL_FRONT, GL_DIFFUSE, @mat_diffuse[0]);

  glLightfv(GL_LIGHT0, GL_AMBIENT, @light_ambient[0]);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, @light_diffuse[0]);
  glLightfv(GL_LIGHT0, GL_POSITION, @light_position[0]);

  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  if Button1.Caption = 'Eigenschaften' then
  begin
    Form1.Width := Form1.Width + 180;
    Button1.Caption := 'Schliessen';
    Panel3.Enabled := true;
    Panel3.Visible := true;
  end else
  begin
    Panel3.Visible := false;
    Panel3.Enabled := false;
    Form1.Width := Form1.Width - 180;
    Button1.Caption := 'Eigenschaften';
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  mat_Light[1] := StrToFloat(Edit5.Text);
  mat_Light[2] := StrToFloat(Edit4.Text);
  mat_Light[3] := StrToFloat(Edit2.Text);
  mat_Light[4] := StrToFloat(Edit3.Text);
  mat_Light[5] := StrToFloat(Edit9.Text);
  mat_Light[6] := StrToFloat(Edit8.Text);
  mat_Light[7] := StrToFloat(Edit6.Text);
  mat_Light[8] := StrToFloat(Edit7.Text);
  mat_Light[9] := StrToFloat(Edit13.Text);
  mat_Light[10] := StrToFloat(Edit12.Text);
  mat_Light[11] := StrToFloat(Edit10.Text);
  mat_Light[12] := StrToFloat(Edit11.Text);
  mat_Light[13] := StrToFloat(Edit17.Text);
  mat_Light[14] := StrToFloat(Edit16.Text);
  mat_Light[15] := StrToFloat(Edit14.Text);
  mat_Light[16] := StrToFloat(Edit15.Text);
  mat_Light[17] := StrToFloat(Edit21.Text);
  mat_Light[18] := StrToFloat(Edit20.Text);
  mat_Light[19] := StrToFloat(Edit18.Text);
  mat_Light[20] := StrToFloat(Edit19.Text);
  mat_Light[21] := StrToFloat(Edit26.Text);
  mat_Light[22] := StrToFloat(Edit25.Text);
  mat_Light[23] := StrToFloat(Edit24.Text);
  mat_Light[24] := StrToFloat(Edit22.Text);
  mat_Light[25] := StrToFloat(Edit23.Text);

  schritt := StrToFloat(Edit1.Text);
  if schritt <= 0 then schritt := 1;
end;

end.

